#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var process = __importStar(require("process"));
var parser_1 = require("../parser");
var validator_1 = __importDefault(require("../validator"));
var normalizer_1 = __importDefault(require("../normalizer"));
var options_1 = require("./options");
var parseCommand = function (options) {
    try {
        var strictSyntax = options.options.includes('strict');
        var upgradeGPLVariants = options.options.includes('upgrade');
        var ast = (0, parser_1.parse)(options.expression, { strictSyntax: strictSyntax, upgradeGPLVariants: upgradeGPLVariants });
        var result = {
            expression: ast,
            errors: (0, validator_1.default)(options.expression).errors
        };
        return JSON.stringify(result, null, 2);
    }
    catch (error) {
        return JSON.stringify({ expression: undefined, errors: [error.message] }, null, 2);
    }
};
var validateCommand = function (options) {
    return JSON.stringify((0, validator_1.default)(options.expression), null, 2);
};
var normalizeCommand = function (options) {
    return (0, normalizer_1.default)(options.expression);
};
var mapOptionsToCommand = function (options) {
    if (options.command === 'normalize') {
        return normalizeCommand;
    }
    else if (options.command === 'validate') {
        return validateCommand;
    }
    else {
        return parseCommand;
    }
};
var cliRunner = function (args) {
    var cliOptions = (0, options_1.parseCLIOptions)(args);
    if (cliOptions.expression.trim().length === 0) {
        console.log((0, options_1.usage)('spdx'));
    }
    else {
        var command = mapOptionsToCommand(cliOptions);
        console.log(command.call(command, cliOptions));
    }
};
function runCLI() {
    cliRunner(process.argv.slice(2));
}
runCLI();
